#!/usr/bin/perl

use strict;

use LWP::UserAgent;
use HTTP::Request;

my $ua = LWP::UserAgent->new();
my $req = HTTP::Request->new( GET => 'http://code.google.com/p/virtual-pbx/downloads/list?can=2&q=VirtualPBX+tgz+update&colspec=Filename' );

my $res = $ua->request($req);

my %ver;

if ( $res->is_success ) {
	my $content = $res->content();

	foreach my $update ( $content =~ /(VirtualPBX-\d+.tgz)/g ) {
		if ( $update =~ /VirtualPBX-(\d+).tgz/ ) {
			$ver{$update} = $1;
		}
	}

	my $cur_ver = `rpm -qv virtual-pbx`;

	$cur_ver =~ s/virtual-pbx-.*_(\d+)(_dev)?$/$1/;

	chomp( $cur_ver );

	my $latest_ver = $ver{(( sort { $ver{$b} <=> $ver{$a} } keys %ver ))[0]};

	if ( $latest_ver > $cur_ver ) {
		print "<br /><br /><a class='error' href='http://code.google.com/p/virtual-pbx/downloads/detail?name=VirtualPBX-$latest_ver.tgz#makechanges'>!!! Update to $latest_ver available !!!</a>";
	} else {
		print "";
	}
}
