#!/usr/bin/perl
########################################################################
#
# $Id: cfg_update.pl,v 1.56 2011-07-03 15:21:00 gosha Exp $
#
#		(c) Okunev Igor <igor[at]prv.mts-nn.ru>
#					2008 - 2011
#
########################################################################
package VirtualPBX;

open STDERR, '>>/var/log/VirtualPBX/XVB.stderr';

use strict;

use vars qw( $VERSION );

($VERSION='$Revision: 1.56 $')=~s/^\S+\s+\d+\.(\d+)\s+.*/$1/;

########################################################################
my %update_data = (
	# top release :)
	"1000000"	=>	[
						'#'x50 . "\n# CFG-VERSION=$VERSION, DATA=". scalar(localtime(time)) ."\n"
	],

	"$VERSION"	=>	[
"####################################################
[TABLES]
VBOX_PARAMS_29			= VPBX_VBOXES_INTERCOM
"
],

	"55"	=>	[
"####################################################
# sip options
[SIP]
#
# REGISTRAR
REGISTRAR					= "
],

	"54"	=>	[
"####################################################
# sip options
[SIP]
#REGISTRAR_TYPE             = SER / ASTERISK
REGISTRAR_TYPE              = SER"
],

	"53"	=>	[
"####################################################
[COMMON]
MEM_CACHED_SHARED		= '127.0.0.1:11211'"
],

	"52"	=>	[
"####################################################
[TABLES]
SIPPEERS_TEMPLATES		= VPBX_SIPPEERS_TEMPLATES
"
],

	"51"	=>	[
"####################################################
[TIMEOUT]
GOOGLE_DATA_TTL				= 300
GOOGLE_DATA					= 43200
GOOGLE_AUTH					= 864000"
],

	"49"	=>	[
"####################################################
[TABLES]
VBOX_PARAMS_28			= VPBX_VBOXES_GC_EXPLORER
"
],

	"48"	=>	[
"####################################################
[FEATURES]
TRANSIT_CALL		= 'xvb-t-record#xvb-t-bg-music-moh#xvb-t-bg-music-play'"
],

	"46"	=>	[
"####################################################
[TIMEOUT]
ICECAST_LEASE                         = 86400
ICECAST_NOLEASE                       = 600

[ASTERISK]
#                                     ices2 [ ogg ] / ezstream [ mp3 ]
ICECAST_FORMAT							= ices2

[PATH]
#ICECAST_DIR						= /opt/Virtual/etc/icecast/

[TABLES]
ICECAST_POOL                  = VPBX_ICECAST_POOL
"
],

	"45"	=>	[
"####################################################
#
# Asterisk options
#
[ASTERISK]
#
# VERISON 16 /18 ( 1.6 / 1.8 )
#
VERSION					= 18
USE_VOICECHANGER		= 0"
],
	
	"43"	=>	[
"####################################################
# CGI options
[CGI]
URL				= /ui"
],

	"42"	=>	[
"####################################################
# PATH description
[PATH]
SOUND_DIR			= /usr/share/asterisk/sounds/"
],

	"41"	=>	[
"####################################################
# TTS FEATURES 
[TTS]
USE_WAV_IF_POSIBLE = 1"
],

	"39"	=>	[
"####################################################
# FILE formats
[FILE]
All_Sound_Formats		= wav|ul|al|ulaw|alaw|g722|gsm"
],

	"38"	=>	[
"####################################################
[FEATURES]
DIALOUT				= 'xvb-transfer#xvb-record#xvb-hangup#xvb-bg-music-moh#xvb-bg-music-play#xvb-pitch'
QUEUES				= 'xvb-transfer#xvb-record#xvb-hangup#xvb-bg-music-moh#xvb-bg-music-play#xvb-pitch'"
],

	"35"	=>	[
"####################################################
[TIMEOUT]
GA_REQUEST			= 1"
],

	"34"	=>	[
"####################################################
#
[DEBUG]
#SEND_TO             = FILE,SYSLOG
SEND_TO             = FILE
FILE                = /var/log/VirtualPBX/XVB.log
HOST                = 127.0.0.1

####################################################
[TIMEOUT]
LOG_REOPEN			= 60"
],

	"33"	=>	[
"####################################################
#
[TABLES]
DIR_LANG				= VPBX_DIRECTORY_LANG"
],
	
	"32"	=>	[
"####################################################
#
# Asterisk options
#
[ASTERISK]
#
# allow Voice Changer. don't work with asterisk 1.6.2
#
USE_VOICECHANGER		= 1"
],

	"31"	=>	[
"####################################################
#
[TABLES]
CDRS_A					= VPBX_CDRS_ACTIVITY"
],

	"30"	=>	[
"####################################################
# Asterisk FEATURES 
[FEATURES]
DIALOUT				= 'xvb-transfer#xvb-record#xvb-hangup'
QUEUES				= 'xvb-transfer#xvb-record#xvb-hangup'
PARKING				= 'xvb-parking'"
],

	"29"	=>	[
"####################################################
# Asterisk FEATURES 
[FEATURES]
DIALOUT				= 'xvb-transfer#xvb-record#xvb-hangup'
QUEUES				= 'xvb-transfer#xvb-record#xvb-hangup'
PARKING				= 'xvb-parking'

####################################################
#
[TABLES]
VBOX_PARAMS_27			= VPBX_VBOXES_PARKING"
],

	"28"	=>	[
"####################################################
# Radius options
[RADIUS]
## accounting
#ACCT_HOST=127.0.0.1
#ACCT_SECRET=testing123
# send accounting events
##ACCT_SEND_EVENTS=1"
],

	"27"	=>	[
"####################################################
[TIMEOUT]
MEM_CACHED_PING				= 60"
],

	"26"	=>	[
"####################################################
# watchdogs th
[WATCHDOG]
TH					= 20
TH_VB				= 8
TH_VB_TIME			= 1"
],

	"25"	=>	[
"####################################################
#
[TABLES]
VBOX_PARAMS_1			= VPBX_VBOXES_PLAYBACK
VBOX_PARAMS_2			= VPBX_VBOXES_RECORD
VBOX_PARAMS_3			= VPBX_VBOXES_DIALOUT
VBOX_PARAMS_4			= VPBX_VBOXES_DIRECTORY
VBOX_PARAMS_5			= VPBX_VBOXES_SCHEDULE
VBOX_PARAMS_6			= VPBX_VBOXES_TTS
VBOX_PARAMS_7			= VPBX_VBOXES_CONFERENCE
VBOX_PARAMS_8			= VPBX_VBOXES_FAXRX
VBOX_PARAMS_9			= VPBX_VBOXES_DTMFRX
VBOX_PARAMS_10			= VPBX_VBOXES_VOTING
VBOX_PARAMS_11			= VPBX_VBOXES_DISA
VBOX_PARAMS_12			= VPBX_VBOXES_PODCAST
VBOX_PARAMS_13			= VPBX_VBOXES_QUEUES
VBOX_PARAMS_14			= VPBX_VBOXES_CALLBACK
VBOX_PARAMS_15			= VPBX_VBOXES_DATETIME
VBOX_PARAMS_16			= VPBX_VBOXES_FAXTX
VBOX_PARAMS_17			= VPBX_VBOXES_BBS
VBOX_PARAMS_18			= VPBX_VBOXES_CALLBLAST
VBOX_PARAMS_19			= VPBX_VBOXES_USERVAR
VBOX_PARAMS_20			= VPBX_VBOXES_WEBVAR
VBOX_PARAMS_21			= VPBX_VBOXES_GOTOIF
VBOX_PARAMS_22			= VPBX_VBOXES_DBVAR
VBOX_PARAMS_23			= VPBX_VBOXES_ALARMCLOCK
VBOX_PARAMS_24			= VPBX_VBOXES_GC_SCHEDULE
VBOX_PARAMS_25			= VPBX_VBOXES_ROBOTEXT
VBOX_PARAMS_26			= VPBX_VBOXES_STREAMING"
],

	"23"	=>	[
"####################################################
#
[TABLES]
VBOX_PARAMS_33554432    = VPBX_VBOXES_STREAMING"
],

	"22"	=>	[
"####################################################
#
# Asterisk options
#
[ASTERISK]
#
# Streaming method: Multi / Single / MultiServer
#
STREAMING_METHOD		= Multi"
],

	"21"	=>	[
"####################################################
#
# Asterisk options
#
[ASTERISK]
#
# PEER IP Function
#		CHANNEL(peerip) // SIPCHANINFO(peerip)
#
PEER_IP					= 'SIPCHANINFO(peerip)'
#
# Asterisk [TR]xFaxAPP: [RT]xFax, ReceiveFax, PIKARxFax
#
RxFax_App				= ReceiveFax
TxFax_App				= SendFax

#
# Dial Method dial/macro
#
DIAL_METHOD				= Macro"
],

	"20"	=>	[
"####################################################
#
# Asterisk options
#
[ASTERISK]
#
# Asterisk Version 1.4 == 14 / 1.6 == 16
#
VERSION					= 16
#
# Asterisk realtime for MOH
#
USE_REALTIME			= 1
#
# DELIMITER: '|' - for 1.4 ( and 1.6 in compat mode=1.4 ), ',' - for 1.6
#
PARAM_DELIMITER			= '|'"
],
	"19"	=>	[
"####################################################
[TABLES]
NOTIFY_TYPE				= VPBX_NOTIFY_TYPE"
],
	"18"	=>	[
"####################################################
[TABLES]
SAY_PATTERN				= VPBX_SAY_PATTERN
VBOX_PARAMS_16777216	= VPBX_VBOXES_ROBOTEXT"
],
	"17"	=>	[
"####################################################
[TABLES]
VBOX_PARAMS_8388608     = VPBX_VBOXES_GC_SCHEDULE"
],

	"16"	=>	[
"####################################################
[TABLES]
VBOX_PARAMS_4194304		= VPBX_VBOXES_ALARMCLOCK"
],

	"15"	=>	[
"####################################################
[TABLES]
VBOX_PARAMS_2097152     = VPBX_VBOXES_DBVAR"
],

	"13"	=>	[
"####################################################
[TABLES]
DID			= VPBX_DIDS

[TIMEOUT]
MEM_CACHED_PREAUTH	= 21600"
],

	"12"	=>	[
"####################################################
[TABLES]
VBOX_PARAMS_1048576		= VPBX_VBOXES_GOTOIF
VBOX_GOTOIF_DATA		= VPBX_VBOXES_GOTOIF_DATA"
],
	"11"	=>	[
"####################################################
[TABLES]
VBOX_PARAMS_524288		= VPBX_VBOXES_WEBVAR"
],
	"10"	=>	[
"####################################################
[TABLES]
VBOX_PARAMS_262144		= VPBX_VBOXES_USERVAR"
],
	"9"	=>	[
"####################################################
# CallBlast optinos
[CALLBLAST]
MAX_PHONES			= 3"
],

	"8"	=>	[
"####################################################
# timeout options
[TIMEOUT]
STAT						= 120"
],

	"7"	=>	[
"####################################################
# common options
[SIP]
#
# REGISTRAR
REGISTRAR					= 127.0.0.1"
],

	"6"	=>	[
"####################################################
# CallBlast optinos
[CALLBLAST]
CHECK_AMD			= 1
MAX_CALLS			= 150
LOAD_THRESHOLD		= 0.90
SLEEP				= 1.5
ATTEMPTS			= 3
CID					= 8478825729
RETRY_TIME			= 30
WAIT_TIME			= 30
RETRIES				= 3

[TIMEOUT]
MEM_CACHED_CALLBLAST		= 300"
],

	"4"	=>	[
"[TABLES]
VBOX_PARAMS_131072		= VPBX_VBOXES_CALLBLAST
VBOX_CALLBLAST_DATA		= VPBX_VBOXES_CALLBLAST_DATA"
],
	"3"	=>	[
"[TABLES]
CUSTOM_MOH				= VPBX_CUSTOM_MOH"
],
	"2"	=>	[
"[TABLES]
VBOX_BBS_DATA			= VPBX_VBOXES_BBS_DATA"	
	]
);

########################################################################
							main();
########################################################################

########################################################################
#
sub main {
	my $cur_version = '0';

	open( IN, '</opt/VirtualPBX/etc/xvb.cfg' ) || die "Can't open config file for read: $!";
	while ( <IN> ) {
		$cur_version = $1 if /CFG-VERSION=(\d+)/;
	}
	close(IN);

	my $start_time = localtime;

	print "Start update config ( from $cur_version to $VERSION ): $start_time...\n";

	if ( $cur_version ne $VERSION ) {
		system "cp /opt/VirtualPBX/etc/xvb.cfg /opt/VirtualPBX/etc/xvb.cfg-$cur_version";
		open( OUT, '>>/opt/VirtualPBX/etc/xvb.cfg' ) || die "Can't open config file for write: $!";
		foreach my $key ( sort { $a <=> $b } keys %update_data ) {
			next if $key <= $cur_version;
			foreach my $conf ( @{ $update_data{$key} } ) {
				print "Add=>: $conf\n\n";
				print OUT "\n$conf\n";
			}
		}
		close OUT;
	}

	my $stop_time = localtime;
	print "Complite update config: $stop_time...\n";
}

